/***************************************************************************

   Copyright (C) 2007 Antonio Aloisio <gnuton@gnuton.org>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the
   Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef IMPORTMEDIADIALOG_H
#define IMPORTMEDIADIALOG_H

#include <QDialog>

#include "ui_importmediadialogbase.h"

namespace KIO
{
class TransferJob;
class Job;

}
class KJob;
namespace KBlogger
{

/**
 * This Dialog Import local and remote media in kblogger
 */

class importMediaDialog : public QDialog, public Ui::importMediaDialogBase
{
    Q_OBJECT
public:
    //Singleton
    static importMediaDialog *self(QWidget* parent = 0);
    //Default destructor
    virtual ~importMediaDialog();

    //
    void addUrl(const QString& url, const QString& blogname, const QString& postId);

    //Overloaded
    void exec();

protected Q_SLOTS:
    //Button functions
    void accept();
    void reject();

private Q_SLOTS:
    void handleFileJobResult( KJob* job );
    void handleFileJobData( KIO::Job* job,  const QByteArray &data);
    void handleFileJobMimetype( KIO::Job* job,  const QString &mimetype );

private:
    //Costructor
    importMediaDialog(QWidget *parent = 0);
    //
    void createMediaFromUrl();

    QList<QTreeWidgetItem*> urls;
    bool hasMedia;
    static importMediaDialog *s_self;

    KIO::TransferJob *fileJob;
    QByteArray *mediaData;
    QString mediaMimetype;
    int i; //List iterator;
};

} //namespace

#endif
