/***************************************************************************

   Copyright (C) 2007 Antonio Aloisio <gnuton@gnuton.org>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the
   Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
 ***************************************************************************/

#include "kbloggerblog.h"

#include <kicon.h>
#include <kmimetype.h>
#include <kdebug.h>

namespace KBlogger
{

kbloggerBlog::kbloggerBlog()
{}

kbloggerBlog::~kbloggerBlog()
{}

void kbloggerBlog::setBlogname( const QString& blogname )
{
    mBlogname = blogname;
}

QString kbloggerBlog::blogname()
{
    return mBlogname;
}

void kbloggerBlog::setUrl( const QString& url )
{
    mUrl = url;
}

KUrl kbloggerBlog::url()
{
    return mUrl;
}

void kbloggerBlog::setUsername( const QString& username )
{
    mUsername = username;
}

QString kbloggerBlog::username()
{
    return mUsername;
}

void kbloggerBlog::setPassword( const QString& password )
{
    mPassword = password;
}

QString kbloggerBlog::password()
{
    return mPassword;
}

void kbloggerBlog::setApi( backend::api_type api)
{
    mApi = api;
}

backend::api_type kbloggerBlog::api()
{
    return mApi;
}

void kbloggerBlog::setBlogId( const QString& id )
{
    mBlogId = id;
}

QString kbloggerBlog::blogId()
{
    return mBlogId;
}

KIcon kbloggerBlog::icon()
{
    QString iconName;
    iconName = KMimeType::iconNameForUrl(mUrl);
    kDebug() << "icona=" << iconName;
    if ( iconName == "www" )
        iconName = "kontact-news";
    return KIcon( iconName );
}

} //namespace
