/***************************************************************************

   Copyright (C) 2005-2007 by Christian Weilbach <christian_weilbach@web.de>
   Copyright (C) 2007 Antonio Aloisio <gnuton@gnuton.org>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the
   Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef UPLOADMEDIADIALOG_H
#define UPLOADMEDIADIALOG_H

#include <QDir>
#include <QDialog>
#include <QString>
#include <QByteArray>

#include <kio/job.h>
#include "ui_uploadmediadialogbase.h"

namespace KIO
{
class TransferJob;
};

namespace KBlogger
{

class KBloggerImageManager;
class kbloggerMedia;
class blogChooser;

class uploadMediaDialog: public QDialog, public Ui::uploadMediaDialogBase
{
    Q_OBJECT
public:
    uploadMediaDialog( const QString& filename = QString(),
                       const QString& blogname = QString(),
                       QWidget *parent = 0);
    virtual ~uploadMediaDialog();

private:
    void insertMediaInTheEditor();

    kbloggerMedia* mMedia;

    QString mBlogname;

    KIO::TransferJob *fileJob;
    blogChooser *mBlogChooser;
    KBloggerImageManager *mImageManager;

    QByteArray mediaData;
    QString mediaMimetype;

private Q_SLOTS:
    void enqueueSlot();

    void handleFileJobResult( KJob* );
    void handleFileJobData( KIO::Job*,  const QByteArray & );
    void handleFileJobMimetype( KIO::Job*, const QString& );

    void setServerFileName(const QString& filename);
};
}
#endif
